require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_NETFILTER_H)) {
    eval 'sub __LINUX_NETFILTER_H {1;}' unless defined(&__LINUX_NETFILTER_H);
    if(defined(&__KERNEL__)) {
	require 'linux/init.ph';
	require 'linux/types.ph';
	require 'linux/skbuff.ph';
	require 'linux/net.ph';
	require 'linux/if.ph';
	require 'linux/wait.ph';
	require 'linux/list.ph';
    }
    require 'linux/compiler.ph';
    eval 'sub NF_DROP {0;}' unless defined(&NF_DROP);
    eval 'sub NF_ACCEPT {1;}' unless defined(&NF_ACCEPT);
    eval 'sub NF_STOLEN {2;}' unless defined(&NF_STOLEN);
    eval 'sub NF_QUEUE {3;}' unless defined(&NF_QUEUE);
    eval 'sub NF_REPEAT {4;}' unless defined(&NF_REPEAT);
    eval 'sub NF_STOP {5;}' unless defined(&NF_STOP);
    eval 'sub NF_MAX_VERDICT { &NF_STOP;}' unless defined(&NF_MAX_VERDICT);
    eval 'sub NF_VERDICT_MASK {0xffff;}' unless defined(&NF_VERDICT_MASK);
    eval 'sub NF_VERDICT_BITS {16;}' unless defined(&NF_VERDICT_BITS);
    eval 'sub NF_VERDICT_QMASK {0xffff0000;}' unless defined(&NF_VERDICT_QMASK);
    eval 'sub NF_VERDICT_QBITS {16;}' unless defined(&NF_VERDICT_QBITS);
    eval 'sub NF_QUEUE_NR {
        my($x) = @_;
	    eval q(((($x <<  &NF_VERDICT_QBITS) &  &NF_VERDICT_QMASK) |  &NF_QUEUE));
    }' unless defined(&NF_QUEUE_NR);
    unless(defined(&__KERNEL__)) {
	eval 'sub NFC_UNKNOWN {0x4000;}' unless defined(&NFC_UNKNOWN);
	eval 'sub NFC_ALTERED {0x8000;}' unless defined(&NFC_ALTERED);
    }
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	if(defined(&CONFIG_NETFILTER)) {
	    eval 'sub NF_MAX_HOOKS {8;}' unless defined(&NF_MAX_HOOKS);
	    eval 'sub NF_LOG_TCPSEQ {0x1;}' unless defined(&NF_LOG_TCPSEQ);
	    eval 'sub NF_LOG_TCPOPT {0x2;}' unless defined(&NF_LOG_TCPOPT);
	    eval 'sub NF_LOG_IPOPT {0x4;}' unless defined(&NF_LOG_IPOPT);
	    eval 'sub NF_LOG_UID {0x8;}' unless defined(&NF_LOG_UID);
	    eval 'sub NF_LOG_MASK {0xf;}' unless defined(&NF_LOG_MASK);
	    eval 'sub NF_LOG_TYPE_LOG {0x1;}' unless defined(&NF_LOG_TYPE_LOG);
	    eval 'sub NF_LOG_TYPE_ULOG {0x2;}' unless defined(&NF_LOG_TYPE_ULOG);
	    unless(defined(&CONFIG_NETFILTER_DEBUG)) {
	    }
	    eval 'sub nf_hook {
	        eval q((\'int\'  &pf, my $hook, \'struct sk_buff\' ** &pskb, \'struct net_device\' * &indev, \'struct net_device\' * &outdev,  &int (* &okfn)) {  &nf_hook_thresh( &pf,  $hook,  &pskb,  &indev,  &outdev,  &okfn,  &INT_MIN, 1); });
	    }' unless defined(&nf_hook);
	    eval 'sub NF_HOOK_THRESH {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn, $thresh) = @_;
    		eval q(({\'int\'  &__ret;  &if (( &__ret= &nf_hook_thresh($pf, $hook, ($skb), $indev, $outdev, $okfn, $thresh, 1)) == 1)  &__ret = ($okfn)($skb);  &__ret;}));
	    }' unless defined(&NF_HOOK_THRESH);
	    eval 'sub NF_HOOK_COND {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn, $cond) = @_;
    		eval q(({\'int\'  &__ret;  &if (( &__ret= &nf_hook_thresh($pf, $hook, ($skb), $indev, $outdev, $okfn,  &INT_MIN, $cond)) == 1)  &__ret = ($okfn)($skb);  &__ret;}));
	    }' unless defined(&NF_HOOK_COND);
	    eval 'sub NF_HOOK {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn) = @_;
    		eval q( &NF_HOOK_THRESH($pf, $hook, $skb, $indev, $outdev, $okfn,  &INT_MIN));
	    }' unless defined(&NF_HOOK);
	    eval 'sub nf_info_reroute {
	        my($x) = @_;
    		eval q((( &void *)$x + $sizeof{\'struct nf_info\'}));
	    }' unless defined(&nf_info_reroute);
	    require 'net/flow.ph';
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub nf_nat_decode_session {
	        my($skb,$fl,$family) = @_;
    		eval q({ });
	    }' unless defined(&nf_nat_decode_session);
	    if(defined(&CONFIG_PROC_FS)) {
		require 'linux/proc_fs.ph';
	    }
	} else {
	    eval 'sub NF_HOOK {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn) = @_;
    		eval q(($okfn)($skb));
	    }' unless defined(&NF_HOOK);
	    eval 'sub NF_HOOK_COND {
	        my($pf, $hook, $skb, $indev, $outdev, $okfn, $cond) = @_;
    		eval q(($okfn)($skb));
	    }' unless defined(&NF_HOOK_COND);
	    eval 'sub nf_hook_thresh {
	        eval q((\'int\'  &pf, my $hook, \'struct sk_buff\' ** &pskb, \'struct net_device\' * &indev, \'struct net_device\' * &outdev,  &int (* &okfn), \'int\'  &thresh, \'int\'  &cond) {  &okfn(* &pskb); });
	    }' unless defined(&nf_hook_thresh);
	    eval 'sub nf_hook {
	        eval q((\'int\'  &pf, my $hook, \'struct sk_buff\' ** &pskb, \'struct net_device\' * &indev, \'struct net_device\' * &outdev,  &int (* &okfn)) { 1; });
	    }' unless defined(&nf_hook);
	    eval 'sub nf_nat_decode_session {
	        my($skb,$fl,$family) = @_;
    		eval q({}  &endif  &endif  &endif );
	    }' unless defined(&nf_nat_decode_session);
1;
