require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SERIO_H)) {
    eval 'sub _SERIO_H {1;}' unless defined(&_SERIO_H);
    require 'linux/ioctl.ph';
    eval 'sub SPIOCSTYPE { &_IOW(ord(\'q\'), 0x1, \'unsigned long\');}' unless defined(&SPIOCSTYPE);
    if(defined(&__KERNEL__)) {
	require 'linux/interrupt.ph';
	require 'linux/list.ph';
	require 'linux/spinlock.ph';
	require 'linux/device.ph';
	require 'linux/mod_devicetable.ph';
	eval 'sub to_serio_port {
	    my($d) = @_;
    	    eval q( &container_of($d, \'struct serio\',  &dev));
	}' unless defined(&to_serio_port);
	eval 'sub to_serio_driver {
	    my($d) = @_;
    	    eval q( &container_of($d, \'struct serio_driver\',  &driver));
	}' unless defined(&to_serio_driver);
	eval 'sub serio_register_port {
	    my($serio) = @_;
    	    eval q({  &__serio_register_port($serio,  &THIS_MODULE); });
	}' unless defined(&serio_register_port);
	eval 'sub serio_unregister_port_delayed {
	    my($serio) = @_;
    	    eval q({  &__serio_unregister_port_delayed($serio,  &THIS_MODULE); });
	}' unless defined(&serio_unregister_port_delayed);
	eval 'sub serio_register_driver {
	    my($drv) = @_;
    	    eval q({  &__serio_register_driver($drv,  &THIS_MODULE); });
	}' unless defined(&serio_register_driver);
	eval 'sub serio_write {
	    my($serio,$data) = @_;
    	    eval q({  &if ( ($serio->{write}))  ($serio->{write})($serio, $data);  &else -1; });
	}' unless defined(&serio_write);
	eval 'sub serio_drv_write_wakeup {
	    my($serio) = @_;
    	    eval q({  &if ( ($serio->{drv})  &&  ($serio->{drv}->{write_wakeup}))  ($serio->{drv}->{write_wakeup})($serio); });
	}' unless defined(&serio_drv_write_wakeup);
	eval 'sub serio_cleanup {
	    my($serio) = @_;
    	    eval q({  &if ( ($serio->{drv})  &&  ($serio->{drv}->{cleanup}))  ($serio->{drv}->{cleanup})($serio); });
	}' unless defined(&serio_cleanup);
	eval 'sub serio_set_drvdata {
	    my($serio,$data) = @_;
    	    eval q({  &dev_set_drvdata( ($serio->{dev}), $data); });
	}' unless defined(&serio_set_drvdata);
	eval 'sub serio_continue_rx {
	    my($serio) = @_;
    	    eval q({  &spin_unlock_irq( ($serio->{lock})); });
	}' unless defined(&serio_continue_rx);
	eval 'sub serio_pin_driver_uninterruptible {
	    my($serio) = @_;
    	    eval q({  &down( ($serio->{drv_sem})); });
	}' unless defined(&serio_pin_driver_uninterruptible);
	eval 'sub serio_unpin_driver {
	    my($serio) = @_;
    	    eval q({  &up( ($serio->{drv_sem})); });
	}' unless defined(&serio_unpin_driver);
    }
    eval 'sub SERIO_TIMEOUT {1;}' unless defined(&SERIO_TIMEOUT);
    eval 'sub SERIO_PARITY {2;}' unless defined(&SERIO_PARITY);
    eval 'sub SERIO_FRAME {4;}' unless defined(&SERIO_FRAME);
    eval 'sub SERIO_XT {0x;}' unless defined(&SERIO_XT);
    eval 'sub SERIO_8042 {0x1;}' unless defined(&SERIO_8042);
    eval 'sub SERIO_RS232 {0x2;}' unless defined(&SERIO_RS232);
    eval 'sub SERIO_HIL_MLC {0x3;}' unless defined(&SERIO_HIL_MLC);
    eval 'sub SERIO_PS_PSTHRU {0x5;}' unless defined(&SERIO_PS_PSTHRU);
    eval 'sub SERIO_8042_XL {0x6;}' unless defined(&SERIO_8042_XL);
    eval 'sub SERIO_UNKNOWN {0x;}' unless defined(&SERIO_UNKNOWN);
    eval 'sub SERIO_MSC {0x1;}' unless defined(&SERIO_MSC);
    eval 'sub SERIO_SUN {0x2;}' unless defined(&SERIO_SUN);
    eval 'sub SERIO_MS {0x3;}' unless defined(&SERIO_MS);
    eval 'sub SERIO_MP {0x4;}' unless defined(&SERIO_MP);
    eval 'sub SERIO_MZ {0x5;}' unless defined(&SERIO_MZ);
    eval 'sub SERIO_MZP {0x6;}' unless defined(&SERIO_MZP);
    eval 'sub SERIO_MZPP {0x7;}' unless defined(&SERIO_MZPP);
    eval 'sub SERIO_VSXXXAA {0x8;}' unless defined(&SERIO_VSXXXAA);
    eval 'sub SERIO_SUNKBD {0x10;}' unless defined(&SERIO_SUNKBD);
    eval 'sub SERIO_WARRIOR {0x18;}' unless defined(&SERIO_WARRIOR);
    eval 'sub SERIO_SPACEORB {0x19;}' unless defined(&SERIO_SPACEORB);
    eval 'sub SERIO_MAGELLAN {0x1a;}' unless defined(&SERIO_MAGELLAN);
    eval 'sub SERIO_SPACEBALL {0x1b;}' unless defined(&SERIO_SPACEBALL);
    eval 'sub SERIO_GUNZE {0x1c;}' unless defined(&SERIO_GUNZE);
    eval 'sub SERIO_IFORCE {0x1d;}' unless defined(&SERIO_IFORCE);
    eval 'sub SERIO_STINGER {0x1e;}' unless defined(&SERIO_STINGER);
    eval 'sub SERIO_NEWTON {0x1f;}' unless defined(&SERIO_NEWTON);
    eval 'sub SERIO_STOWAWAY {0x20;}' unless defined(&SERIO_STOWAWAY);
    eval 'sub SERIO_H3600 {0x21;}' unless defined(&SERIO_H3600);
    eval 'sub SERIO_PS2SER {0x22;}' unless defined(&SERIO_PS2SER);
    eval 'sub SERIO_TWIDKBD {0x23;}' unless defined(&SERIO_TWIDKBD);
    eval 'sub SERIO_TWIDJOY {0x24;}' unless defined(&SERIO_TWIDJOY);
    eval 'sub SERIO_HIL {0x25;}' unless defined(&SERIO_HIL);
    eval 'sub SERIO_SNES232 {0x26;}' unless defined(&SERIO_SNES232);
    eval 'sub SERIO_SEMTECH {0x27;}' unless defined(&SERIO_SEMTECH);
    eval 'sub SERIO_LKKBD {0x28;}' unless defined(&SERIO_LKKBD);
    eval 'sub SERIO_ELO {0x29;}' unless defined(&SERIO_ELO);
    eval 'sub SERIO_MICROTOUCH {0x30;}' unless defined(&SERIO_MICROTOUCH);
}
1;
